//	DLLt@C̃GNX|[gĂ֐̈ꗗ\
//	Visual C++ 2008/2013 32/64bit

#include <windows.h>
#include <commctrl.h>
#include <tchar.h>
#include <imagehlp.h>
#include "resource.h"
#include <vector>
#pragma comment(lib,"imagehlp.lib")

typedef TCHAR* TCHARP;

std::vector<TCHARP> funcName;	//	GNX|[g֐̈ꗗ
TCHAR* szClassName=TEXT("dll2list");
HINSTANCE hInst;
HWND hList;	//	Xgr[̃nh
TCHAR def_dir[MAX_PATH];	//	R_CAÕfBtHgfBNg

//	_CAO{bNXvV[W[
LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

//	EBhEvV[W[
LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

//	DLLŃGNX|[gĂ֐̈ꗗ쐬
bool dllFuncList(TCHAR* dllName,std::vector<TCHARP>& func,HWND hWnd=0);

//	Xgr[̕\eݒ
void set_lvs(HWND hList);

// t@Cw肷R_CAO\
BOOL GetFileName(HWND hWnd, TCHAR* fname, int sz, TCHAR* initDir = 0);

// t@Cw肷R_CAO\
BOOL GetSaveName(HWND hWnd, TCHAR* fname, int sz, TCHAR* initDir = 0);

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPreInst,TCHAR* lpszCmdLine, int nCmdShow){
    HWND hWnd;
	MSG lpMsg;
	WNDCLASS wc;
	hInst=hInstance;
	if (!hPreInst) {
		wc.style=CS_HREDRAW | CS_VREDRAW;
		wc.lpfnWndProc=WndProc;
		wc.cbClsExtra=0;
		wc.cbWndExtra=0;
		wc.hInstance=hInstance;
		wc.hIcon=NULL;
		wc.hCursor=LoadCursor(NULL, IDC_ARROW);
		wc.hbrBackground = (HBRUSH__ *)GetStockObject(LTGRAY_BRUSH);
		wc.lpszMenuName = _TEXT("IDM_MENU");
		wc.lpszClassName=szClassName;
		if (!RegisterClass(&wc))
			return FALSE;
	}
	hWnd = CreateWindow(szClassName,
		TEXT("Dll2List"),
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		450,
		450,
		NULL,
		NULL,
		hInstance,
		NULL);
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	while (GetMessage(&lpMsg, NULL, 0, 0)) {
		TranslateMessage(&lpMsg);
		DispatchMessage(&lpMsg);
	}
	return int(lpMsg.wParam);
}

//	EBhEvV[W[

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	TCHAR buf[MAX_PATH];
	TCHAR title[MAX_PATH];
	LV_COLUMN lvcol;
	static HWND hEdit=0;
	static HWND hButton = 0;
	static HMENU hMenu = 0;
	static HMENU hSubMenu = 0;
	switch (msg){
	case WM_CREATE:{
		hList = CreateWindowEx(0,
			WC_LISTVIEW, TEXT(""),
			WS_CHILD | WS_VISIBLE | LVS_REPORT,
			0, 0, 0, 0,
			hWnd,
			(HMENU)ID_LISTVIEW,
			hInst,
			NULL);

		lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
		lvcol.fmt = LVCFMT_LEFT;
		lvcol.cx = 32;
		lvcol.pszText = TEXT("No.");
		lvcol.iSubItem = 0;
		ListView_InsertColumn(hList, 0, &lvcol);

		lvcol.fmt = LVCFMT_LEFT;
		lvcol.cx = 256;
		lvcol.pszText = TEXT("֐");
		lvcol.iSubItem = 1;
		ListView_InsertColumn(hList, 1, &lvcol);

		hMenu=GetMenu(hWnd);
		hSubMenu= GetSubMenu(hMenu, 0);
		EnableMenuItem(hSubMenu, IDM_SAVE, MFS_DISABLED);
		def_dir[0]=_T('\0');
		break;
	}
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDM_OPEN:
			if (DialogBoxParam(::hInst, TEXT("OPEN_DLG"), hWnd, (DLGPROC)DlgProc1, (LPARAM)buf) == TRUE){
				for (unsigned n = 0; n < ::funcName.size(); n++){
					free(::funcName[n]);	//	_tcsdupŊmۂ
				}
				::funcName.clear();
				if (dllFuncList(buf, ::funcName, hWnd) == false)
					break;
#ifdef _WIN64
				_stprintf_s(title, MAX_PATH, _TEXT("%s 64Bit"), buf);
#else
				_stprintf_s(title, MAX_PATH, _TEXT("%s 32Bit"), buf);
#endif
				SetWindowText(hWnd, title);
				SendMessage(hList, LVM_DELETEALLITEMS, 0, 0);
				set_lvs(hList);
				EnableMenuItem(hSubMenu, IDM_SAVE, MFS_ENABLED);
			}
			break;
		case IDM_SAVE:
			if (GetSaveName(hWnd, buf, MAX_PATH, def_dir)){
				FILE* fp;
				if (_tfopen_s(&fp, buf, _TEXT("w"))){
					MessageBox(hWnd, buf, _TEXT("ȉ̃t@CI[v邱Ƃł܂ł"), MB_OK);
					break;
				}
				for (unsigned n = 0; n<::funcName.size(); n++){
					_ftprintf(fp,_TEXT("%s\n"),::funcName[n]);
				}
				fclose(fp);
			}
			break;
		case IDM_EXIT:
			SendMessage(hWnd, WM_DESTROY, 0, 0);
			break;
		}
		break;
	case WM_SIZE:
		MoveWindow(hList, 0, 0, LOWORD(lParam), HIWORD(lParam) , TRUE);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break; 

	default:
		return(DefWindowProc(hWnd, msg, wParam, lParam));
	}
	return (0L);
}

//	DLLŃGNX|[gĂ֐̈ꗗ쐬

bool dllFuncList(TCHAR* dllName,std::vector<TCHARP>& func,HWND hWnd){
	unsigned i, j;
	ULONG  nSize;
	DWORD* funcTable;
	WORD*  numTable;
	IMAGE_EXPORT_DIRECTORY* pImage;

	HMODULE hMod = LoadLibrary(dllName);

	if (hMod == NULL) {
		MessageBox(hWnd,_TEXT("DLL[h邱Ƃł܂ł"),_TEXT("G[") , MB_OK);
		return false;
	}
	//GNX|[gfBNg̎擾
	pImage = (IMAGE_EXPORT_DIRECTORY*)ImageDirectoryEntryToData(
		(PVOID)hMod, TRUE, IMAGE_DIRECTORY_ENTRY_EXPORT, &nSize);
	if (pImage == NULL) {
		MessageBox(hWnd,_TEXT("GNX|[gfBNg擾邱Ƃł܂ł"),_TEXT("G[") , MB_OK);
		FreeLibrary(hMod);
		return false;
	}

	int count = 0;
	//	V{
	funcTable = (DWORD*)(pImage->AddressOfNames + (BYTE*)hMod);
	//	e[u
	numTable = (WORD*)(pImage->AddressOfNameOrdinals + (BYTE*)hMod);
	for (i = 0; i < pImage->NumberOfFunctions; i++)	{	//	GNX|[ge[u	
		for (j = 0; j < pImage->NumberOfNames; j++) {	//	V{e[u
			if (numTable[j] != i)	//ł͂ȂCfbNXł邽ߖ
				continue;
			char* ansi = (char*)(funcTable[j] + (BYTE*)hMod);
			TCHAR* func_name;
#ifdef	_UNICODE
			WCHAR utf[128];
			MultiByteToWideChar(932, 0, ansi, -1, utf, sizeof(utf) / sizeof(TCHAR));
			func_name = utf;
#else
			func_name = ansi;
#endif
			TCHAR* p = _tcsdup(func_name);
			func.push_back(p);
			++count;
			break;
		}
	}
	FreeLibrary(hMod);
	return true;
}

//	Xgr[̕\eݒ

void set_lvs(HWND hList){
	LV_ITEM item;
	TCHAR buf[16];
	for(unsigned i=0; i< ::funcName.size();i++){

		_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%d"), i + 1);
		item.mask = LVIF_TEXT;

		item.pszText = buf;
		item.iItem = i;
		item.iSubItem = 0;
		ListView_InsertItem(hList, &item);

		item.mask = LVIF_TEXT;
		item.pszText = ::funcName[i]; 
		item.iItem = i;
		item.iSubItem = 1;
		ListView_SetItem(hList, &item);

		item.mask = LVIF_TEXT;
		item.pszText = _TEXT("");
		item.iItem = i;
		item.iSubItem = 2;
		ListView_SetItem(hList, &item);
	}
}

//	_CAO{bNXvV[W[

LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	static TCHAR* buf = 0;
	switch (msg) {
	case WM_INITDIALOG:
		buf = (TCHAR*)lParam;
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_REF_BUTTON:
			if (GetFileName(hDlg, buf, MAX_PATH, def_dir)){
				SetWindowText(GetDlgItem(hDlg, IDC_DLL_EDITBOX), buf);
			}
			break;
		case IDOK:
			GetDlgItemText(hDlg, IDC_DLL_EDITBOX, (TCHAR*)buf, MAX_PATH);
			EndDialog(hDlg, TRUE);
			return TRUE;
		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			return FALSE;
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}
	return TRUE;
}

// t@Cw肷R_CAO\

BOOL GetFileName(HWND hWnd, TCHAR* fname, int sz, TCHAR* initDir){
	OPENFILENAME o;
	fname[0] = _T('\0');
	ZeroMemory(&o, sizeof(o));
	o.lStructSize = sizeof(o);		//	\̃TCY
	o.hwndOwner = hWnd;				//	eEBhẼnh
	o.lpstrInitialDir = initDir;	//	tH_[
	o.lpstrFile = fname;			//	擾t@Cۑobt@
	o.nMaxFile = sz;				//	擾t@Cۑobt@TCY
	o.lpstrFilter = _TEXT("DLLt@C(*.DLL)\0*.DLL\0");
	o.lpstrDefExt = _TEXT("DLL");
	o.lpstrTitle = _TEXT("DLLt@Cw");
	o.nFilterIndex = 1;
	return GetOpenFileName(&o);
}

// t@Cw肷R_CAO\

BOOL GetSaveName(HWND hWnd, TCHAR* fname, int sz, TCHAR* initDir){
	OPENFILENAME o;
	fname[0] = _T('\0');
	ZeroMemory(&o, sizeof(o));
	o.lStructSize = sizeof(o);		//	\̃TCY
	o.hwndOwner = hWnd;				//	eEBhẼnh
	o.lpstrInitialDir = initDir;	//	tH_[
	o.lpstrFile = fname;			//	擾t@Cۑobt@
	o.nMaxFile = sz;				//	擾t@Cۑobt@TCY
	o.lpstrFilter = _TEXT("TXTt@C(*.TXT)\0*.TXT\0") _TEXT("SẴt@C(*.*)\0*.*\0");
	o.lpstrDefExt = _TEXT("TXT");
	o.lpstrTitle = _TEXT("o̓t@Cw");
	o.nFilterIndex = 1;
	return GetSaveFileName(&o);
}
